#include <stdio.h>
#include <stdlib.h>
#include "dptm2.h"

extern int ary_flags[];
extern int num_fname_in;
extern char** ary_fname_in;
extern char fname_out[];
extern char* fname_log;
extern FILE* fplog;

int main( int argc, char* argv[] )
{
	int ierr;
	FILE* fpin;
	FILE* fpout;

	ierr = 0;
	fpin  = NULL;
	fpout = NULL;

	/* read commandline-arguments */
	ierr = flags_readcmd( argc, argv );
	if( ierr != 0 ) goto postprocess;

	/* open log file */
	ierr = fopen_log( fname_log, FALSE );
	if( ierr != 0 ) goto postprocess;

	/* allocate memory */
	ierr = mem_init( MEM_BASE );
	if( ierr != 0 ) goto postprocess;

	/* convert PS files */
	if( num_fname_in > 0 )
	{
		int i;

		for( i = 0; i < num_fname_in; i++ )
		{
			if( !ary_flags['A'] )   /* append OFF */
			{
				fname_out[0] = '\0';
			}
			if( fopen_ps( ary_fname_in[i], fname_out, &fpin, &fpout ) == 0 )
			{
				ierr = psio_main( fpin, fpout, i+1, num_fname_in );
			}
			fclose_ps( &fpin, &fpout );
			if( ierr != 0 ) break;
			ary_flags['A'] |= ary_flags['C'];   /* if cat-mode, turn ON append-mode. */
		}
	}
	else
	{
		/* pipeline-mode (STDIN->STDOUT) */
		chprintf( 'F', fplog, "Input : %s\n", "(STDIN)"  );
		chprintf( 'F', fplog, "Output: %s\n", "(STDOUT)" );
		fputs( "Pipeline-mode.\n", stderr );
		fputs( "Press Ctrl+D if you stop inputting.\n", stderr );
		psio_main( stdin, stdout, 0, 0 );
	}

	/* postprocess */
postprocess:
	mem_fin();
	fclose_log();
	flags_free();
#ifdef WAITCLOSE
	flags_waitclose();
#endif

	return 0;
}
