#ifndef DPTM2_H
#define DPTM2_H

#define NDEBUG   /* for release ver. */

/* parameter */
#define MEM_BASE 1024     /* initial memory length */
#define MEMLENMAX (1<<26) /* check 2GB limit! */
#define NUM_BUCKET 8000   /* check dcl.ps points! */
#define MAXSFXNUM 99
#define MAX_PATH 260
#define PS_BUFLEN 100     /* 60 for default dcl.ps */
#define PSHEADMAX 1000    /* 920 for default dcl.ps */

#ifdef _MSC_VER
#define WAITCLOSE   /* use waitclose() in flags.c */
#endif

/* macro */
#define L2STR( l ) ( (l) ? "TRUE" : "FALSE" )
#define free2( ptr ) if( ptr != NULL ){ free( ptr ); ptr = NULL; }
#define numof( ary ) ( sizeof( ary ) / sizeof( (ary)[0] ) )

/* type */
#define TRUE  1
#define FALSE 0
typedef int BOOL;
typedef signed short intPoint;   /* check mem_pathopt ! */
typedef unsigned int intCount;   /* expansion for 64-bit */
typedef struct s_Node
{
	intPoint x;
	intPoint y;
	char op[4];
	struct s_Node* prev;
	struct s_Node* next;
}s_Node;

/* function prototype */
size_t strncpy2( char* dst, const char* src, size_t size );
int strncat2( char* dst, const char* src, size_t count, size_t buflen );
BOOL exist_file( const char* fname );

int chprintf( int ch, FILE* fp, const char* str, ... );
void display_help( void );
void display_version( void );

int mem_init( intCount num_base );
int mem_flush( void );
int mem_newpath( void );
int mem_addnode( s_Node* p_node_in );
int mem_setpath( BOOL closed );
intCount mem_alias( void );
int mem_rsort( void );
intCount mem_tonemerge( void );
intCount mem_pathopt( void );
intCount mem_output_tone( FILE* fp );
intCount mem_output_line( FILE* fp );
int mem_fin( void );

int fopen_log( char* fname_log, BOOL append );
void fclose_log( void );
int fopen_ps( const char fname_in[], char fname_out[], FILE** fppsin, FILE** fppsout );
void fclose_ps( FILE** fppsin, FILE** fppsout );

int pickup_param1( char* buf );
int flags_readcmd( int argc, char* argv[] );
int flags_waitclose( void );
void flags_free( void );

int psio_main( FILE* fpin, FILE* fpout, int num_thisfile, int num_allfiles );

#endif
