#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <assert.h>
#include "dptm2.h"

/* similar to "strlcpy", size=sizeof(dst) */
size_t strncpy2( char* dst, const char* src, size_t size )
{
	size_t i;

	for( i = 0; i < size; i++ )
	{
		dst[i] = src[i];
		if( src[i] == '\0' ) break;
	}
	if( i == size ) dst[size-1] = '\0';   /* dst always has '\0' */

	return i;
}

/* safer than strncat.  count=maxlen(src), buflen=maxlen(dst) */
int strncat2( char* dst, const char* src, size_t count, size_t buflen )
{
	if( strnlen( src, count ) + strnlen( dst, buflen ) + 1 < buflen )
	{
		strncat( dst, src, count - 1 );   /* -1 is for '\0' */
		return 0;
	}
	else
	{
		return 1;
	}
}

BOOL exist_file( const char* fname )
{
	FILE* fp;
	BOOL exist;

	fp = fopen( fname, "r" );
	exist = ( fp != NULL );
	if( exist ) fclose( fp );

	return exist;
}

